#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "terminal.h"
#include "board.h"
#include "moves.h"
#include "finished.h"

/*------------------------------------------------------------------------*/

int main() {

	int width, height; 	/* Breite und Hoehe des Spielfeldes. */
	int x, y; 			/* Aktuelle Position des Weihnachtsmannes. */
	int level;			/* Levelnummer. */
	char **field;		/* Spielfeld. */
	int **target;		/* Zielfelder. */
	char *datei;		/* Dateiname. */
	char ch;			/* Welche Taste? */

	level = 1;
    datei = calloc(sizeof(char),12);
	sprintf(datei, "level%02d.dat", level);	

	read_level(datei, &field, &target, &width, &height, &x, &y);
	print_boardcolored(field, target, width, height, x, y, level);

	/* Alten Terminalzustand speichern, neuen setzen */
	store();
	while ((ch = getchar()) != 'q') {
	    if (ch == 'i') {
			move_player(field, &x, &y, 0, -1, width, height);
		    print_boardcolored(field, target, width, height, x, y, level);
		}
	    else if (ch == 'm') {
			move_player(field, &x, &y, 0, 1, width, height);
		    print_boardcolored(field, target, width, height, x, y, level);
		}
	    else if (ch == 'j') {
			move_player(field, &x, &y, -1, 0, width, height);
		    print_boardcolored(field, target, width, height, x, y, level);
		}
	    else if (ch == 'l') {
			move_player(field, &x, &y, 1, 0, width, height);
		    print_boardcolored(field, target, width, height, x, y, level);
		}
        if (level_finished(field, target, width, height) == 1) {
            level++;
            discard(&field, &target, width, height);
            sleep(1);
            printf("\nJuppieh, Level geschafft! Nchster Level wird geladen!\n");
            //fflush(stdout);
            sleep(2);
            sprintf(datei, "level%02d.dat", level);
            read_level(datei, &field, &target, &width, &height, &x, &y);
            print_boardcolored(field, target, width, height, x, y, level);
        }		
	}
	/* Alten Terminalzustand wieder herstellen. */
	restore();

	return 0;
}
