#include "moves.h"

/* Ist ein Zug bzgl. der akt. Pos. um dx bzw. dy moeglich? */
int move_possible(char **f, int x, int y, int dx, int dy, int w, int h) {

	int x1 = x + dx;
	int y1 = y + dy;
	/* Eine Position weiter als die Zielposition berechnen! */
	int x2 = x + 2 * dx;
	int y2 = y + 2 * dy;

	/* Groesserer Schritt als 1 bzgl. einer Koordinate? */
	if (!( (dx == 0 && dy*dy == 1) || (dx*dx == 1 && dy == 0) )) {
		return 0;
	}

	/* Zielposition nicht im Feld? */
	if (x1 < 0 || x1 >= w || y1 < 0 || y1 >= h) {
		return 0;
	}

	/* Zielposition leer? */
	if ( f[x1][y1] == ' ') {
		return 1;
	}

	/* Ist Zielposition + 1 Feld weiter innerhalb des Feldes? */
	if (x2 < 0 || x2 >= w || y2 < 0 || y2 >= h) {
		return 0;
	}

	/* Ist bei (x1, y1) eine Kiste und bei (x2, y2) leer, dann Ok! */
	if (f[x1][y1] == '*' && f[x2][y2] == ' ') {
		return 1;
	}

	return 0;

} 

/* Falls Zug moeglich dann ausfuehren! */
void move_player(char **f, int *x, int *y, int dx, int dy, int w, int h) {

	int x1 = *x + dx;
	int y1 = *y + dy;

	int x2 = *x + 2 * dx;
	int y2 = *y + 2 * dy;

	if ((move_possible(f, *x, *y, dx, dy, w, h)) == 1) {
		if (f[x1][y1] != ' ') {
			/* Kiste verschieben. */
			f[x2][y2] = f[x1][y1];
			f[x1][y1] = ' ';
		}
		*x = x1; *y = y1;
	}	
}
