#include "terminal.h"

#include <termios.h>
#include <stdio.h>

struct termios origstate;

/* Alten Terminalzustand speichern (von stdin = id 0). */
void store() {
    struct termios changedstate;

    if (tcgetattr(0, &origstate) != 0)
    printf("tcgetattr failed");
    changedstate = origstate;

    /* Neuen Terminalzustand setzen (von stdin = id 0). */
    changedstate.c_lflag &= ~ICANON; /* disable canonical input */
    changedstate.c_lflag &= ~ECHO;   /* disable output */
    changedstate.c_cc[VMIN] = 1;     /* min = 1 */
    changedstate.c_cc[VTIME] = 1;    /* time = 1/10 sec */
    if (tcsetattr(0, TCSANOW, &changedstate) != 0)
    printf("tcsetattr failed");
}

/* Alten Terminalzustand wiederherstellen (von stdin = id 0). */
void restore() {
    if (tcsetattr(0, TCSANOW, &origstate) != 0)
    printf("tcsetattr failed");
}
